import pygame
from pygame.locals import *
pygame.init()
 
fenetre = pygame.display.set_mode((920, 640))
pygame.display.set_caption("Bataille_navale")
clock = pygame.time.Clock()
font = pygame.font.SysFont(None, 32)
liste_messages = []

BLANC = (255, 255, 255)
NOIR = (0, 0, 0)
ROUGE = (255, 0, 0)
BLEU = (0, 0, 255)
JAUNE = (255, 255, 0)

def affichage(d, g):
    #f.fill(NOIR)
    for col in range(10):
        text = font.render(str(col), 1, BLANC)
        fenetre.blit(text, (d + 57 + col * 40, 20))
    for ligne in range(10):
        text = font.render(str(chr(65+ligne)), 1, BLANC)
        fenetre.blit(text, (d + 25, 52 + ligne * 40))
        for col in range(10):
            pygame.draw.rect(fenetre, BLANC, (d + 40 + col *40, 40 + ligne * 40, 40, 40), 2)
            if g[ligne][col] > 20: # coulé
                pygame.draw.rect(fenetre, ROUGE, (d + 40 + col *40, 40 + ligne * 40, 40, 40), 0)
            elif g[ligne][col] > 10: # touché
                pygame.draw.circle(fenetre, ROUGE, (d + 60 + col *40, 60 + ligne * 40), 16, 0)
            elif g[ligne][col] == 10: # dans l'eau
                pygame.draw.circle(fenetre, BLEU, (d + 60 + col *40, 60 + ligne * 40), 16, 0)
            
            #pygame.time.delay(42)
            pygame.display.flip()
            
def saisie_nom():
    text = font.render("Saisir votre nom, capitaine : ", 1, BLANC)
    fenetre.blit(text, (480, 300))
    pseudo = "Igloo"
    while True:
        clock.tick(25)
        nom = font.render(pseudo, 1, BLANC)
        pygame.draw.rect(fenetre, NOIR, (470, 342, 330, 70), 0)
        fenetre.blit(nom, (480, 350))
        pygame.display.flip()
        #gestion des événements
        for event in pygame.event.get():
            if event.type == QUIT: #la croix en haut à gauche
                fin()
            elif event.type == KEYDOWN:
                if event.key == K_BACKSPACE:
                    if len(pseudo) > 0:
                        pseudo = pseudo[:-1]
                elif event.key == K_RETURN:
                    affiche_plein_ecran_et_attend("Bienvenue K'p'tain " + pseudo, 1000)
                    affiche_plein_ecran_et_attend("Clique, K'p'tain " + pseudo, 0)
                    return pseudo
                elif len(pseudo) < 18:
                    pseudo += event.dict['unicode']

def saisie_coup(nom):
    while True: # c'est mal
        clock.tick(25) # 25 images / seconde
        #gestion des événements
        for event in pygame.event.get():
            if event.type==QUIT: #la croix en haut à gauche
                fin()
            elif event.type==MOUSEBUTTONUP : # clic de souris
                x, y = event.pos
                if 40 <= x <= 440 and 40 <= y <= 440:
                    # on vire l'espace de 40 à gauche et en haut
                    x -= 40 
                    y -= 40
                    return x // 40, y // 40
            
def message(chaine):
    '''
        Cette fonction attend une chaîne de caractères chaine
        Affiche les cinq derniers éléments de la liste
        liste_messages déjà enregistrée (variable globale)
        Affiche message
        Elle rajoute message à cette liste
    '''
    pygame.draw.rect(fenetre, NOIR, (40, 480, 400, 120), 0)
    hauteur = 480
    for ligne in liste_messages[-2:]:
        surf = font.render(ligne, 1, BLANC)
        fenetre.blit(surf, (40, hauteur))
        hauteur += 40
        pygame.display.flip()
    surf = font.render(chaine, 1, BLANC)
    fenetre.blit(surf, (40, hauteur))
    pygame.display.flip()
    liste_messages.append(chaine)

def affiche_score(d, score):
    pygame.draw.rect(fenetre, NOIR, (580, 30, 220, 40), 0)
    surf = font.render("Score : " + str(score), 1, JAUNE)
    fenetre.blit(surf, (d + 40, 10))
    pygame.display.flip()

def affiche_plein_ecran_et_attend(message, temps):
    pygame.draw.rect(fenetre, NOIR, (470, 130, 320, 430), 0)
    surf = font.render(message, 1, BLANC)
    fenetre.blit(surf, (480, 142))
    pygame.display.flip()
    pygame.time.delay(temps)

def fin():
    affiche_plein_ecran_et_attend("Fin de partie !", 2000)
    pygame.quit()
